from tkinter import *
from threeD import *

def gouraudShading(canvas, a, an,L0, ca, v0):
    Num=len(a.p)
    pp=[0 for i in range(Num)]
    cc=[0 for i in range(Num)]
    for i in range(Num):
        pp[i]=screen(a.p[i])                    #screen座標系への変換
        V = unit(a.p[i]-v0)                     #視線ベクトル
        L = unit(a.p[0]-L0)                     #照明ベクトル
        cc[i]=shading(V, L, unit(an.p[i]), ca)
    n=Num-1
    RR=rangeScreen(pp, Num)
    y_min=RR[0]; y_max=RR[1] 
    s=[0,0,0,0]; s[0]=RR[2]; s[1]=RR[3]
    for y in range(int(y_min), int(y_max+1)):
        s = setSID(pp, s, n, y)
        p0=pp[s[0]]; p1=pp[s[1]]; p2=pp[s[2]]; p3=pp[s[3]]
        c0=cc[s[0]]; c1=cc[s[1]]; c2=cc[s[2]]; c3=cc[s[3]]
        p4 = interPos(p1, p2, y) #p1,p2を補間
        c4 = interCol(c1, c2, y-int(p1.y), int(p2.y)-y) #c1,c2を補間
        p5 = interPos(p0, p3, y) #p0,p3を補間
        c5 = interCol(c0, c3, y-int(p0.y), int(p3.y)-y) #p0,p3を補間
        for x in range(int(p4.x), int(p5.x+1)):
            pp4=x-p4.x; pp5=p5.x-x
            p = interpolate(p4, p5, pp4, pp5)
            if z_buff[x][y]<=p.z: #以前描画した画素より手前にあれば描画
                C = interCol(c4, c5,  pp4, pp5).toString()
                drawPointXY(canvas, x,y,C)
                z_buff[x][y]=p.z 
        
#■メインプログラム
root= Tk()
root.title("3D Methods(gouraud shading)")
canvas=Canvas(root,width=500,height=400)
canvas.pack()
z_buff=[[-1e30 for j in range(400)] for i in range(500)]
init2D(500,400)
origin(250,200)
V0= Point(500,500,500)              #視点
L0= Point(0,500,1000)               #照明光
setview(V0)
#drawAxisXYZ(canvas)
#b=circle_xy(36)                    #円形(補助線用)
a=circle_xz(18)                     #ドーナツ形の生成
aa=a*50
Fig=revolve_z(move(100,0,0)*aa,36)  #軸から100離れたところの円を回転
Fnm=revolve_z(aa,36)                #ドーナツ形の法線
Num=len(Fig.polygon)
for i in range(Num):
    gouraudShading(canvas,Fig.polygon[i],Fnm.polygon[i], L0, Color(0x77, 0x77, 0xFF),V0)
a=circle_xz(18,0,180)               #球体の生成
Fig=move(0,0,50)*revolve_z(a*70,36) #円を回転して球を作成する
Fnm=revolve_z(a,36)                 #球体の法線
Num=len(Fig.polygon)
for i in range(Num):
     gouraudShading(canvas,Fig.polygon[i],Fnm.polygon[i], L0, Color(0xFF,0x77, 0xFF),V0)
#a=circle_xz(18);aa=a*50
#drawLine(canvas, move(100,0,0)*aa, 'red')
#drawLine(canvas, b*150, 'red')
